CATMULL_SHIFT equ 8


flat_triangle_z_float:
;  Procedure draw triangle with Z coordinate interpolation --------
;  (Catmull  alghoritm). This version uses float z coordinate -----
;  interpolation and inner loop optimized using AVX instructions.--
;  ----------------------------------------------------------------
;  ----------------in - eax - x1 shl 16 + y1 ----------------------
;  -------------------- ebx - x2 shl 16 + y2 ----------------------
;  -------------------- ecx - x3 shl 16 + y3 ----------------------
;  -------------------- edx - color 0x00RRGGBB --------------------
;  -------------------- esi - pointer to Z-buffer -----------------
;  -------------------- edi - pointer to screen buffer-------------
;  -------------------- stack : z coordinates
;  -------------------- Z-buffer : each delta z variable as dword
;  -------------------- float , coords as dword float
.z1	equ dword[ebp+4]
.z2	equ dword[ebp+8]    ; each z coordinate as dword float
.z3	equ dword[ebp+12]

.col	equ dword[ebp-4]
.x1	equ word[ebp-6]
.y1	equ word[ebp-8]
.x2	equ word[ebp-10]
.y2	equ word[ebp-12]
.x3	equ word[ebp-14]
.y3	equ word[ebp-16]

.dx12	equ dword[ebp-20]
;.dz12   equ dword[ebp-24]
.dx13	equ dword[ebp-24]
.dz13	equ dword[ebp-28]
.dz12	equ dword[ebp-32]
;.dz13   equ dword[ebp-32]
.dx23	equ dword[ebp-36]
;.dz13M  equ      [ebp-40]
.dz23	equ dword[ebp-44]
.zz1	equ dword[ebp-48]
.zz2	equ dword[ebp-52]
.temp	equ [ebp-56]
;.zz2M   equ qword[ebp-52]
;.dz12M  equ qword[ebp-32]
;.dz23M  equ qword[ebp-44]
;if Ext>=MMX
;        emms
;end if
	mov	ebp,esp
	fninit

	push	edx	       ; store edx in variable .col
      .sort2:
	cmp	ax,bx
	jle	.sort1
	xchg	eax,ebx
	mov	edx,.z1
	xchg	edx,.z2
	mov	.z1,edx
      .sort1:
	cmp	bx,cx
	jle	.sort3
	xchg	ebx,ecx
	mov	edx,.z2
	xchg	edx,.z3
	mov	.z2,edx
	jmp	.sort2
      .sort3:
	push	eax	       ; store triangle coordinates in user friendly variables
	push	ebx
	push	ecx
	 mov	  edx,80008000h  ; eax,ebx,ecx are ANDd together into edx which means that
	 and	  edx,ebx	 ; if *all* of them are negative a sign flag is raised
	 and	  edx,ecx
	 and	  edx,eax
	 test	  edx,80008000h  ; Check both X&Y at once
	 jne	  .ft_loop2_end
       ;  cmp      ax,SIZE_Y
       ;  jle      @f
       ;  cmp      bx,SIZE_Y
       ;  jle      @f
       ;  cmp      cx,SIZE_Y
       ;  jge      @f
       ;  ror      eax,16
       ;  ror      ebx,16
       ;  ror      ecx,16
       ;  cmp      ax,SIZE_X
       ;  jle      @f
       ;  cmp      bx,SIZE_X
       ;  jle      @f
       ;  cmp      cx,SIZE_X
       ;  jle      @f
       ;  jmp      .ft_loop2_end
       ;@@:
	sub	esp,128 ;52-12-4

	mov	bx,.y2	     ; calc delta 12
	sub	bx,.y1
	jnz	.ft_dx12_make
	mov	.dx12,0
	mov	.dz12,0.0
	jmp	.ft_dx12_done
   .ft_dx12_make:
	mov	ax,.x2
	sub	ax,.x1
	cwde
	movsx	ebx,bx
	shl	eax,ROUND
	cdq
	idiv	ebx
	mov	.dx12,eax

;        mov     ax,.z2
;        sub     ax,.z1
;        cwde
;        shl     eax,CATMULL_SHIFT
;        cdq
;        idiv    ebx
;        mov     .dz12,eax
	 fninit
	 fld	 .z2
	 fsub	 .z1
	 mov	 .temp,ebx
	 fidiv	 dword .temp
	 fstp	 .dz12
  .ft_dx12_done:
	mov	bx,.y3	     ; calc delta 13
	sub	bx,.y1
	jnz	.ft_dx13_make
	mov	.dx13,0
	mov	.dz13,0.0
   ;     mov     dword .dz13M,0
	jmp	.ft_dx13_done
   .ft_dx13_make:
	mov	ax,.x3
	sub	ax,.x1
	cwde
	movsx	ebx,bx
	shl	eax,ROUND
	cdq
	idiv	ebx
	mov	.dx13,eax

;        mov     ax,.z3
;        sub     ax,.z1
;        cwde
;        shl     eax,CATMULL_SHIFT
;        cdq
;        idiv    ebx
;        mov     .dz13,eax
;        mov     dword .dz13M,eax
	 fld	 .z3
	 fsub	 .z1
	 mov	 .temp,ebx
	 fidiv	 dword .temp
	 fstp	 .dz13

    .ft_dx13_done:
	mov	bx,.y3	     ; calc delta 23
	sub	bx,.y2
	jnz	.gt_dx23_make
	mov	.dx23,0
	mov	.dz23,0.0
	jmp	.gt_dx23_done
   .gt_dx23_make:
	mov	ax,.x3
	sub	ax,.x2
	cwde
	movsx	ebx,bx
	shl	eax,ROUND
	cdq
	idiv	ebx
	mov	.dx23,eax

;        mov     ax,.z3
;        sub     ax,.z2
;        cwde
;        shl     eax,CATMULL_SHIFT
;        cdq
;        idiv    ebx
;        mov     .dz23,eax
	 fld	 .z3
	 fsub	 .z2
	 mov	 .temp,ebx
	 fidiv	 dword .temp
	 fstp	 .dz23

    .gt_dx23_done:

	mov	edx,.z1
;        shl     edx,CATMULL_SHIFT
	mov	.zz1,edx
	mov	.zz2,edx
	movsx	eax,.x1
	shl	eax,ROUND    ; eax - x1
	mov	ebx,eax      ; ebx - x2
;if Ext>=MMX
;        movq    mm0,.zz2M
;end if
	mov	cx,.y1
	cmp	cx,.y2
	jge	.ft_loop1_end
     .ft_loop1:

	pushad

	push	.col
	push	cx	    ; y
	sar	ebx,ROUND
	push	bx	    ; x2
	sar	eax,ROUND
	push	ax	    ; x1
;if Ext>=MMX
;        sub     esp,8
;        movq    [esp],mm0       ;
;else
	push	.zz2	    ; z2 shl CATMULL_SHIFT
	push	.zz1	    ; z1 shl CATMULL_SHIFT
;end if
	call	flat_line_z_float

	popad

	add	eax,.dx13
	add	ebx,.dx12
;if  Ext>=MMX
;        paddd   mm0,.dz12M
;else

;        mov     edx,.dz13
;        add     .zz1,edx
;        mov     edx,.dz12
;        add     .zz2,edx
	fninit
	fld	.zz1
	fadd	.dz13
	fstp	.zz1
	fld	.zz2
	fadd	.dz12
	fstp	.zz2
;end if
	inc	cx
	cmp	cx,.y2
	jl	.ft_loop1
    .ft_loop1_end:

;        movsx   edx,.z2
;        shl     edx,CATMULL_SHIFT
	mov	edx,.z2
	mov	.zz2,edx
	movsx	ebx,.x2
	shl	ebx,ROUND
;if Ext>=MMX
;        movq    mm0,.zz2M
;;        push    .dz13    ; exchange
;;        pop     .dz12
;;        push    .dz23    ; exchange
;;        pop     .dz13
;end if
	mov	cx,.y2
	cmp	cx,.y3
	jge	.ft_loop2_end
     .ft_loop2:
	pushad

	push	.col
	push	cx
	sar	ebx,ROUND
	push	bx
	sar	eax,ROUND
	push	ax	    ; x1
;if Ext>=MMX
;        sub     esp,8
;        movq    [esp],mm0
;else
	push	.zz2	    ; z2 shl CATMULL_SHIFT
	push	.zz1	    ; z1 shl CATMULL_SHIFT
;end if
	call	flat_line_z_float

	popad

	add	eax,.dx13
	add	ebx,.dx23
;if  Ext>=MMX
;        paddd   mm0,.dz23M
;else
;        mov     edx,.dz13
;        add     .zz1,edx
;        mov     edx,.dz23
;        add     .zz2,edx
	fninit
	fld	.zz1
	fadd	.dz13
	fstp	.zz1
	fld	.zz2
	fadd	.dz23
	fstp	.zz2

;        mov     edx,.dz13
;        add     .zz1,edx
;        mov     edx,.dz12
;        add     .zz2,edx
;end if
	inc	cx
	cmp	cx,.y3
	jl	.ft_loop2
     .ft_loop2_end:

	mov esp,ebp
ret 12

flat_line_z_float:
;----------------
;-------------in edi - pointer to screen buffer ----------------------------------
;--------------- esi - pointer to z-buffer (each Z varible dword)-----------------
;----------stack Z coords - (each z coordinate 32 bit float)------------------
.z1 equ dword [ebp+4]
.z2 equ dword [ebp+8]
.x1 equ word  [ebp+12]
.x2 equ word  [ebp+14]
.y  equ word  [ebp+16]
.col equ dword [ebp+18]

.dz equ dword [ebp-4]
.dzIV  equ ebp-8
.dzIII equ ebp-12
.dzII  equ ebp-16
.dzI   equ ebp-20
.czIV  equ ebp-24
.czIII equ ebp-28
.czII  equ ebp-32
.czI   equ ebp-36
.temp  equ ebp-40
.rest  equ ebp-44
     fninit
     mov	ebp,esp
     sub	esp,68

     mov	ax,.y
     or 	ax,ax
     jl 	.fl_quit
;;     mov        bx,[size_y]
;;     dec        bx
;     cmp        ax,[size_y]
     cmp	ax,SIZE_Y-1
     jg 	.fl_quit

     mov	ax,.x1
     cmp	ax,.x2
     je 	.fl_quit
     jl 	.fl_ok

     xchg	ax,.x2
     mov	.x1,ax
     mov	edx,.z1
     xchg	edx,.z2
     mov	.z1,edx
   .fl_ok:
     cmp	.x1,SIZE_X-1
     jg 	.fl_quit
     cmp	.x2,0
     jle	.fl_quit


     fld       .z2
     fsub      .z1
     mov       bx,.x2
     sub       bx,.x1
     movsx     ebx,bx
     mov       [.temp],ebx
     fidiv     dword [.temp]
     fstp      .dz
;;     mov        .dz,eax                ; calculated delta - shifted .dz



     cmp	.x1,0
     jge	@f
     movsx	ebx,.x1
     neg	ebx
     mov	[.temp],ebx
     fld	.dz
     fimul	dword [.temp]
     fadd	.z1
     fstp	.z1
     mov	.x1,0
    @@:
     cmp	.x2,SIZE_X
     jl 	@f
     mov	.x2,SIZE_X
    @@:
     mov	edx,SIZE_X
     movsx	eax,.y
     mul	edx		     ; edi = edi + (SIZE_X * y + x1)*4
     movsx	edx,.x1
     add	eax,edx
				     ; esi = esi + (SIZE_X * y + x1)*4

     shl	eax,2
     add	esi,eax
     add	edi,eax

     mov	cx,.x2
     sub	cx,.x1
     movzx	ecx,cx


     vbroadcastss ymm2,.z1
     vbroadcastss ymm3,.dz

     vmovaps	  ymm1,ymm3
     vmulps	  ymm3,ymm3,yword[muler0_7]
     vaddps	  ymm2,ymm2,ymm3 ; ymm2 -> cz
     vaddps	  ymm1,ymm1,ymm1
     vaddps	  ymm1,ymm1,ymm1
     vaddps	  ymm1,ymm1,ymm1 ; ymm1 -> dz * 8

     or 	 .col,0xff000000
     vbroadcastss ymm7,.col
     mov	[.rest],cx
     and	word[.rest],0x0007
     shr	ecx,3
     jecxz	.draw_last

   .ddraw:
     vmovups	ymm0,[esi]  ; esi -> pointer to z buffer
			    ; packed compare Z buffer
     vcmpnleps	ymm0,ymm0,ymm2	; use "[esi]" instead of ymm0 in 2cond arg

if 1	      ; various options of AVX
      vmaskmovps [edi],ymm0,ymm7
				   ; draw color

      vmaskmovps [esi],ymm0,ymm2
				   ; actualize z buffer

else
     vmovups	ymm6,[edi]
     vblendvps	ymm6,ymm6,ymm7,ymm0 ; use [edi] instead one ymm6
     vmovups	[edi],ymm6
				    ; draw color
     vmovups	ymm5,[esi]
     vblendvps	ymm5,ymm5,ymm2,ymm0 ;use [esi] instead one ymm5
     vmovups	[esi],ymm5
				    ; actulaize z buffer

end if

   @@:
     add	edi,32
     add	esi,32
     vaddps	ymm2,ymm2,ymm1

     loop	.ddraw

   .draw_last:
     movzx	ecx,word[.rest]
     jecxz	.fl_quit
    ;jmp     .fl_quit
;     psrldq     xmm2,12
;     addss      xmm2,.dz
     mov	eax,.col
     or 	eax,0xff000000
   .ddraw_last:
     movaps	xmm0,xmm2
     cmpnless	xmm0,[esi]   ; compare Z buffer
     pmovmskb	ebx,xmm0     ; check cause if all bits are zeroed
     test	ebx,0x00000001
     jnz	@f

;     comiss     xmm2,dword[esi]  ;lowest dword float of xmm2 -> current z coord
;     jl         @f               ; this code won't run correct.
     mov	dword[edi],eax
     movss	dword[esi],xmm2
   @@:
     addss	xmm2,.dz
     add	esi,4
     add	edi,4
     loop	.ddraw_last
   .fl_quit:

     mov   esp,ebp
ret 18
