;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ave Cruce Salus Mea
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program: Win3ds04 - 3ds files viewer + demonstration
;;          of several graphics effects.
;; author:  Maciej Guba aka macgub
;; web   :  www.macgub.hekko.pl
;; email :  macgub3@wp.pl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Key description : SPACE -  switching
;;          beetwen displaying models: flat, smooth
;;          shading, spherical environment, texture,
;;          bump, smooth + texture, two texture and bump
;;          + texture mapping pararell, edges only
;;          (smooth shaded, textured lines), flat
;;          with float single precision Z coordinate;
;;          TAB - generate three unlinear lights (Phongs
;;          illumination); F3/F4 keys - zoom in/out;
;;          F1 - motion blur on/off; F2 - switching between
;;          objects (from file and predefined: heart and 
;;          tetrahedron); F5 - choose bumps mapping planar
;;          od spherical; F6 - switching between random 
;;          bumps and texture dependent; F7 - select 
;;          texture: red white stripes and 2d version of
;;          one predefined 3d object; ESC - exit.
;;          After run program shows dialog to open file.
;;          Choose 3ds file and ...admire. ;)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Program needs SSE2, SSE3, SSE4.1 or AVX extension.
;; Coding style is rather not perfect. Other words it's
;; my own mess :D.
format PE GUI 4.0
entry start

include '/include/win32a.inc'

XRES equ 1200 ;800 ;1600 ;1200 ;800      ;choose screen size
YRES equ 675  ;450 ;900 ; 675 ;450
SIZE_X	equ XRES
SIZE_Y	equ YRES
TEX_X = 512    ; texture size
TEX_Y = 512
TEXTURE_SIZE EQU (TEX_X * TEX_Y)-1
TEX_SHIFT = 9
TRIANGLES_COUNT equ 4
POINTS_COUNT equ 4
ROUND equ 8
NON  = 0  ; --\
MMX  = 1  ;    > this definitions are only for upside down
SSE  = 2  ; --/  compatible reasons
SSE2 = 3
SSE3 = 4
SSE4.1 = 5
AVX = 6
Ext  = SSE2

section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
; threads is present and future :)
;                     invoke  GetCurrentProcess
;                     invoke  GetProcessAffinityMask,eax,ProcessAffinityMask,SystemAffinityMask
;
;                        lea  edi,[ThreadMaskArray]
;                        mov  eax,[ProcessAffinityMask]
;                        xor  ecx,ecx
;                  @@:   mov  ebx,eax
;                        sub  eax,1
;                        and  eax,ebx
;                        xor  ebx,eax
;                        add  ecx,1
;                        mov  [edi],ebx
;                        add  edi,4
;                       test  eax,eax
;                        jnz  @b
;                        mov  [CoreCount],ecx

    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    mov [bmi.biSize],sizeof.BITMAPINFOHEADER
    mov [bmi.biWidth],XRES
    mov [bmi.biHeight],-YRES-30
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0

    mov [rect.left],0
    mov [rect.top],0
    mov [rect.right],XRES+0
    mov [rect.bottom],YRES+30
    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0 

    invoke RegisterClass,wc

    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left] 

    invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
	   xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW

    invoke timeGetTime
    mov [s_time],eax	     ;initialize start time
    pushad
    mov    eax,YRES / 2
    cvtsi2ss xmm0,eax
    movss  [scale],xmm0
;    invoke StretchDIBits,[hdc],0,0,XRES,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
    call   open_file
  ;  invoke StretchDIBits,[hdc],0,0,XRES,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPYCCOPY
    call   read_from_file
    pushad
    push   dword points_r
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    popad

    call   init_triangles_normals2
    call   init_point_normals
    call   normalize_all_light_vectors
    call   init_envmap2
    call   do_color_buffer
    mov    edi,bump_map
    call   calc_bumpmap
    call   calc_bumpmap_coords
    call   generate_texture2
;    invoke StretchDIBits,[hdc],0,0,XRES,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
    popad
msg_loop:
    invoke timeGetTime
    sub eax,[s_time]
    mov [e_time],eax	     ;get new end time

    stdcall g_draw
    inc  [ccounter]
    and  [ccounter],0x000000ff
    invoke StretchDIBits,[hdc],0,30,XRES,YRES+30,0,0,XRES,YRES,buffer,bmi,0,SRCCOPY
 ;;  invoke StretchDIBits,[hdc],0,30,TEX_X,TEX_Y+30,0,0,TEX_X,TEX_Y,texmap,bmi,0,SRCCOPY
 ;   BOOL TextOut(
 ; _In_  HDC hdc,
 ; _In_  int nXStart,
 ; _In_  int nYStart,
 ; _In_  LPCTSTR lpString,
 ; _In_  int cchString

 ;   invoke StretchDIBits,[hdc],0,0,XRES,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY

    movzx  eax,[draw_flag]
    mov    ebx,36
    mul    ebx
    add    eax,sh_model
    invoke TextOut,[hdc],10,10,eax,36

  ;  invoke StretchDIBits,[hdc],0,0,TEX_X,TEX_Y,0,0,TEX_X,TEX_Y,color_map,bmi,0,SRCCOPY

    invoke Sleep,2

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop

    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:
    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
;    invoke StretchDIBits,[hdc],0,0,XRES,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
    cmp [wmsg],WM_KEYDOWN
    je .wmkeydown
    cmp [wmsg],WM_DESTROY
    je .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp .finish
  .wmkeydown:
    cmp [wparam],VK_UP
    jne .vescape_or_set_shading

;    stdcall g_init
    xor eax,eax
    jmp .finish
  .vescape_or_set_shading:
    cmp [wparam],VK_SPACE
    jne .next_cmp
    inc [draw_flag]
    cmp [draw_flag],14
    jne  @f
    mov [draw_flag],0
   @@:
    invoke StretchDIBits,[hdc],0,0,XRES,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
  .next_cmp:
    cmp   [wparam],VK_TAB
    jne   @f
    call  make_random_lights
    call  normalize_all_light_vectors
    call  do_color_buffer
    call  init_envmap2
  @@:
    cmp   [wparam],VK_F1
    jne   @f
    not   [blur_flag]
  @@:
    cmp   [wparam],VK_F2
    jne   .next_mes
    inc   [hrt_flag]
    cmp   [hrt_flag],3
    jne   @f
    mov   [hrt_flag],0
  @@:
    cmp   [hrt_flag],1
    jne   @f
    call  read_hrt
    jmp   .skip11
  @@:
    cmp   [hrt_flag],2
    jne    @f
    call   load_tetrahedron
    jmp   .skip11
  @@:
 ;   cmp   [hrt_flag],3
 ;   jne    @f
 ;   call   load_tetrahedron
 ;   jmp   .skip11
  @@:
    pushad
    call   read_from_file
    popad
  .skip11:

    pushad
    push   dword points_r
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords

;    cmp   [wparam],VK_F2
;    jne   @f
;    call  open_file
;    call  read_from_file
;    call  normalize_object
;    call  init_triangles_normals2
;    call  init_point_normals

  .next_mes:
    cmp   [wparam],VK_F3  ;ADD
    je	  @f

;       call   init_triangles_normals2
;    call   init_point_normals
;    call   normalize_all_light_vectors
;    call   init_envmap2
;    call   do_color_buffer
;    mov    edi,bump_map
;    call   calc_bumpmap
;    call   calc_bumpmap_coords
    cmp   [wparam],VK_ADD
    jne   .next_mes6
  @@:
    fninit
    fld   [scale]
    fmul  [scale_plus]
    fstp  [scale]
  .next_mes6:
    cmp   [wparam],VK_F4  ;SUBTRACT
    je	  @f
    cmp   [wparam],VK_SUBTRACT
    jne   .next_mes5
  @@:
    fninit
    fld   [scale]
    fmul  [scale_minus]
    fstp  [scale]
  .next_mes5:
    cmp   [wparam],VK_F5
    jne   .next_mes2
    inc   [map_flag]	     ; bump, texture - spherical or planar mapping ?
    cmp   [map_flag],2
    jne   @f
    mov   [map_flag],0
  @@:
    call  calc_bumpmap_coords
  .next_mes2:
    cmp   [wparam],VK_F6
    jne   .next_mes3	      ; bumps - random or texture dependent ?
    inc   [bump_flag]
    cmp   [bump_flag],2
    jne   @f
    mov   [bump_flag],0
  @@:
    call  calc_bumpmap
  .next_mes3:
    cmp   [wparam],VK_F7
    jne   .next_mes4	      ; bumps - random or texture dependent ?
    inc   [tex_flag]
    cmp   [tex_flag],2
    jne   @f
    mov   [tex_flag],0
  @@:
    cmp   [tex_flag],0
    jne   @f
    call  generate_texture2    ; draw stripes
    call  calc_bumpmap	       ; should I recreate bumps ?
    jmp   .next_mes4
  @@:
    call  generate_texture1	; draw heart
    call  calc_bumpmap		; should I recrete bumps ?
  .next_mes4:
    cmp [wparam],VK_ESCAPE
    jne .finish
  .wmdestroy:
    invoke PostQuitMessage,0
    xor eax,eax
  .finish:
    ret
endp
open_file:
;   xor     eax,eax
;   mov     edi,fname
;   cld
;   mov     ecx,260/4
;   rep     stosd

   mov	   [ofn.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofn
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfile],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfile],0
   cmp	   eax,-1
   je	   .failed
   mov	   [FileSize],eax
   cmp	   [pmem],0
   jne	   .heap_realloc
   invoke  GetProcessHeap
   mov	   [hheap],eax
   invoke  HeapAlloc,[hheap],0,[FileSize]
   jmp	   .read_file

 .heap_realloc:
   invoke  HeapReAlloc,[hheap],0,[pmem],[FileSize]

 .read_file:
   mov	   [pmem],eax
   mov	   ebx,eax
   invoke  ReadFile,[hfile],[pmem],[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfile]
   mov	   [hfile],0

   mov	   eax,[BytesRead]
   mov	   cx,WORD [ebx]
   cmp	   cx,'MM'
   jne	   .read_error
;  mov     edx,[ebx+2]
   mov	   [File_ptr],ebx
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret


 .read_error:
   invoke  HeapFree,[hheap],0,[pmem]
   mov	   [pmem],0

 .failed:
   cmp	   [hfile],0
   je	   @f
   invoke  CloseHandle,[hfile]
  @@:
   invoke  MessageBox,[hwnd],_not3ds,0,MB_OK
   .cancel:
   invoke ReleaseDC,[hwnd],[hdc]
   invoke DestroyWindow,[hwnd]
   invoke ExitProcess,[msg.wParam]
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer; main program proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw ;uses ebx esi edi
local .temp dw ?, .rot_flag dw ?
;local .first_p_index dd ?, .second_p_index dd ?, .third_p_index dd ?
;local .zz1 dw ?, .zz2 dw ?, .zz3 dw ? ;-> don't change order
local .zz1f dd ?, .zz2f dd ?, .zz3f dd ?
local .xx1 dw ?, .xx2 dw ?, .xx3 dw ?
local .yy1 dw ?, .yy2 dw ?, .yy3 dw ?
local .xy1 dd ?, .xy2 dd ?, .xy3 dd ?
local .dpr dd ?, .dpr_p dd ?
local .x_temp_var dd ?, .y_temp_var dd ?
local .counter dd ?
  ;  invoke start_timing

    pushad
    cmp   [blur_flag],0
    jne   @f
    xor   eax,eax	   ; clear draw buffer
    mov   edi,buffer
    cld
    mov   ecx,XRES * YRES
    rep   stosd
    jmp   .no_blur
  @@:
    mov   ecx,1
    call  blur_screen
  .no_blur:
    cmp   [draw_flag],10
    je	  @f
    mov   eax,5000*65536    ; make background to Zbuffer
    jmp   .m_back
  @@:
    mov   eax,6000.1
  .m_back:
    mov   edi,Zbuffer
    mov   ecx,XRES * YRES
    rep   stosd


  .rotate:
    fninit
    fild   [ccounter]
    fmul   [one_deg]

;    cmp    [hrt_flag],0
;    jne    @f
;    fld    st
;   @@:
    fld    st
    fsincos
    fst   dword[cos_beta]
    fchs
    fstp  [neg_cos_beta]
    fst   [sin_beta]
    fchs
    fstp  [neg_sin_beta]

    cmp    [hrt_flag],0
    je	   @f
    cmp    [hrt_flag],2
    je	   @f
    mov   dword[cos_gamma],0.98480775301220805936674302458952
    mov   [sin_gamma],0.17364817766693034885171662676931
    mov   [neg_cos_gamma],-0.98480775301220805936674302458952
    mov   [neg_sin_gamma],-0.17364817766693034885171662676931
    jmp   .skip2
  @@:
    fld1
    fld1
    faddp
    fmulp

    fsincos
    fst   dword[cos_gamma]
    fchs
    fstp  [neg_cos_gamma]
    fst   [sin_gamma]
    fchs
    fstp  [neg_sin_gamma]
 .skip2:
    mov    [.rot_flag],0
 .rot_points_and_normals:
    mov    esi,points_r 	; rotate points
    mov    edi,points_rotated
    jmp    .do_rot
 .rot_normals:
    mov    esi,points_normals
    mov    edi,points_normals_rotated
 .do_rot:
    movzx  ecx,[points_count_var]

 .again_rot:
if Ext >= SSE3
    movlps xmm0,[esi+4]
    shufps xmm0,xmm0,01000100b
    movaps xmm1,[cos_gamma]
    shufps xmm1,xmm1,00110100b
    mulps  xmm0,xmm1
    haddps xmm0,xmm0
;    shufps xmm0,xmm0,11100100b
    movlps [edi+4],xmm0
else
    fld    dword[esi+4]
    fmul   dword[cos_gamma]
    fld    dword[esi+8]
    fmul   [sin_gamma]
    faddp
    fld    dword[esi+4]
    fmul   [sin_gamma]
    fchs
    fld    dword[esi+8]
    fmul   dword[cos_gamma]
    faddp
    fstp   dword[edi+8]
    fstp   dword[edi+4]
end if

    push   dword[esi]
    pop    dword[edi]

if Ext>=SSE3
    movups xmm2,[edi]
    shufps xmm2,xmm2,10001000b
    movaps xmm3,[cos_beta]
    shufps xmm3,xmm3,00011100b
    mulps  xmm3,xmm2
    haddps xmm3,xmm3
 ;   shufps xmm3,xmm3,11000001b

    movss  [edi+8],xmm3
    psrldq xmm3,4
    movss  [edi],xmm3
else

    fld    dword[edi]
    fld    st
    fmul   dword[cos_beta]
    fld    dword[edi+8]
    fmul   [sin_beta]
    fchs
    faddp
    fstp   dword[edi]
    fmul   [sin_beta]
    fld    dword[edi+8]
    fmul   dword[cos_beta]
    faddp
    fstp   dword[edi+8]
end if
    add    esi,12
    add    edi,12
  ;  cmp    dword[esi],-1
  ;  jnz    @b
  ;  loop   .again_rot
    dec    ecx
    jnz    .again_rot
if 0
    mov       edi,points_rotated
    movss     xmm1,[scale]
    shufps    xmm1,xmm1,0
    movlps    xmm2,[xxadd]
    pxor      xmm3,xmm3
    punpcklwd xmm2,xmm3
    cvtdq2ps  xmm2,xmm2
    movzx     ecx,[points_count_var]
  @@:
    movups    xmm0,[edi]
    mulps     xmm0,xmm1
    addps     xmm0,xmm2
    movlps    [edi],xmm0
    psrldq    xmm0,8
    movss     [edi+8],xmm0
    add       edi,12
    loop      @b

end if

    inc    [.rot_flag]
    cmp    [.rot_flag],1
    jle    .rot_normals

    push   dword[esi]
    pop    dword[edi]


    mov   esi,triangles 	   ; draw triangles
    movzx ecx,[triangles_count_var]
  .draw_triangle:
    push  ecx
    fninit
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [first_p_index],edx
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fiadd word[xxadd]
    fistp [.xx1]
    movzx eax,[.xx1]
    shl   eax,16
    fld   dword[edx+4]
    fmul  [scale]
    fiadd [yyadd]
    fistp [.yy1]
    mov   ax,[.yy1]
    fld   dword[edx+8]
    fmul  [scale]
    fiadd [zzadd]
    fist  word[zz1]
    fstp  [.zz1f]
					; z coord - skip
    movzx edx,word[esi+2]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [second_p_index],edx
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fiadd word[xxadd]
    fistp [.xx2]
    movzx ebx,[.xx2]
    shl   ebx,16
    fld   dword[edx+4]
    fmul  [scale]
    fiadd [yyadd]
    fistp [.yy2]
    mov   bx,[.yy2]
    fld   dword[edx+8]
    fmul  [scale]
    fiadd [zzadd]
    fist  [zz2]
    fstp  [.zz2f]

    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [third_p_index],edx
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fiadd word[xxadd]
    fistp [.xx3]
    movzx ecx,[.xx3]
    shl   ecx,16
    fld   dword[edx+4]
    fmul  [scale]
    fiadd [yyadd]
    fistp [.yy3]
    mov   cx,[.yy3]
    fld   dword[edx+8]
    fmul  [scale]
    fiadd [zzadd]
    fist  [zz3]
    fstp  [.zz3f]

    mov     [.xy1],eax
    mov     [.xy2],ebx
    mov     [.xy3],ecx

    push  esi
    pushad

    cmp   [draw_flag],1
    je	  .flat_draw
    cmp   [draw_flag],3
    je	  .env_mapping
;    je    .flat_draw_float
;    cmp   [draw_flag],8
;    je    .flat_draw_float
    cmp   [draw_flag],4
    je	  .bump_mapping
    cmp   [draw_flag],5
    je	  .tex_mapping
    cmp   [draw_flag],8
    je	  .bump_tex_mapping
    cmp   [draw_flag],7
    je	  .two_tex
    cmp   [draw_flag],6
    je	  .grd_tex
    cmp   [draw_flag],9
    je	  .grd_line
    cmp   [draw_flag],10
    je	  .flat_draw_float
    cmp   [draw_flag],0
    je	  .draw_dots
    cmp   [draw_flag],11
    je	  .tex_line
    cmp   [draw_flag],12
    je	  .tex_line
    cmp   [draw_flag],13
    je	  .flat_line


     .grd_draw: 	       ;****Gouraud shading****
	fninit


	mov	esi,third_p_index
	mov	ecx,3
      .again_grd_draw:
	mov	eax,[esi]
	add	eax,points_normals_rotated
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+zz1-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_draw

if 0
   ; -----------version with only one light supported------
    mov   [.counter],4	    ; ++++ gouraud shading  ++++++++
  .calc_col_LVD:    ; calculate color Light Vector Depend
    mov   edx,[.counter]
    push  [zz1+edx]
; calc color of triangle light vector dependent
    mov   esi,light_vect
    mov   edi,points_normals_rotated
    add   edi,[first_p_index+2*edx]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx


    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

;    shufps    xmm3,xmm3,11000110b

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxuw    xmm3,[minimum0]
;    pminuw    xmm3,[maximum255]

    movd      edx,xmm3
  ;  ror       edx,16
    push      edx
    psrldq    xmm3,4
    movd      edx,xmm3
    push      dx

    sub   [.counter],2
    cmp   [.counter],0
    jge   .calc_col_LVD


end if

    mov     eax,[.xy1]
    mov     ebx,[.xy2]
    mov     ecx,[.xy3]

    mov   esi,Zbuffer
    mov   edi,buffer
    call  gouraud_triangle_z
    jmp   .end_draw

  .draw_dots:
	mov	edi,buffer
;------------
	mov	eax,[.xy1]

	cmp	ax,SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	ror	eax,16

	cmp	ax,SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	mov	edx,SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1
;------------------
	mov	eax,[.xy2]

	cmp	ax,SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16

	cmp	ax,SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	mov	edx,SIZE_X
	ror	eax,16

	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1
;------------------
	mov	eax,[.xy3]

	cmp	ax,SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16

	cmp	ax,SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	mov	edx,SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	jmp   .end_draw
  .grd_line:		    ;****Gouraud line****
	fninit


	mov	esi,third_p_index
	mov	ecx,3
      .again_grd_line_param:
	mov	eax,[esi]
	add	eax,points_normals_rotated
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	mov	[ecx*4+col1-4],eax

	sub	 esi,4
	dec	 ecx			; decode all 3 edges
	jnz	 .again_grd_line_param


	mov	edi,buffer
	mov	esi,Zbuffer

	mov	eax,[col1]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	word[zz1]

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	mov	eax,[col2]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	[zz2]

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	call	smooth_line	; draw only one edge

    jmp   .end_draw



  .tex_line:		    ;****textured line****

if 0

    ;  10 lines below - - test goals

       push  dword 1 * 65536 + 1
       push  word[zz1]
       push  dword 100 *65536 + 100
       push  dword 500 * 65536 + 500
       push  word [zz2]
       push  dword 100 *65536 + 400

	mov	edi,buffer
	mov	esi,Zbuffer
     ;   mov     edx,envmap
     ;   cmp     [draw_flag],12
     ;   jne     @f
	mov	edx,texmap
  ;   @@:int3
	call	tex_line


       jmp   .end_draw



end if


	cmp	[draw_flag],12
	je	@f

	fninit
	sub	esp,4
	mov	edx,[first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff1
     @@:
	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]
     .pushzbuff1:
	push	word[zz1]

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	cmp	[draw_flag],12
	je	@f
	sub	esp,4
	mov	edx,[second_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff2
     @@:
	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]
     .pushzbuff2:

	push	[zz2]

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	mov	edi,buffer
	mov	esi,Zbuffer
	mov	edx,envmap
	cmp	[draw_flag],12
	jne	@f
	mov	edx,texmap
     @@:
	call	tex_line     ; draw only one edge

    jmp   .end_draw

  .flat_line:		     ;****simple line****
			     ; without z coord. interpolation

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    or		eax,ecx
    test	eax,80008000h
    jne 	.end_draw

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    cmp 	ax,SIZE_Y
    jg		.end_draw
    cmp 	cx,SIZE_Y
    jg		.end_draw
    ror 	eax,16
    cmp 	ax,SIZE_X
    jg		.end_draw
    ror 	ecx,16
    cmp 	cx,SIZE_X
    jg		.end_draw

	mov	 eax,[.xy1]
    ;    ror      eax,16
	movzx	 ebx,ax
	shr	 eax,16
	mov	 ecx,[.xy2]
   ;     ror      ecx,16
	movzx	 edx,cx
	shr	 ecx,16
      ;  push     dword 0x00ffffff

	call	 linea

	jmp	.end_draw


    .grd_tex:

	fninit

	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov	esi,third_p_index
	mov	ecx,3

      .again_grd_tex_draw:

	mov	eax,[esi]
	add	eax,points_normals_rotated
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+zz1-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_tex_draw


	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,buffer   ; screen buffer
	mov	esi,Zbuffer
	mov	edx,texmap

	call	tex_plus_grd_triangle

	jmp    .end_draw



     .flat_draw:		     ;**************************                                     ; FLAT DRAWING
	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,[first_p_index]
	add	eax,points_normals_rotated
	fld	dword[eax]
	mov	ebx,[second_p_index]
	add	ebx,points_normals_rotated
	fadd	dword[ebx]
	mov	ecx,[third_p_index]
	add	ecx,points_normals_rotated
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.x_temp_var] ;[esp-4]    ; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.y_temp_var];[esp-8]   ;  y
	mov	edx,[.x_temp_var]  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,[.y_temp_var] ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax

	lea	edi,[buffer]
	mov	esi,Zbuffer
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	call	flat_triangle_z

    jmp   .end_draw






    .env_mapping:
	push	[zz3]
	push	[zz2]
	push	word[zz1]
	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

	mov	edi,buffer   ; screen buffer
	mov	esi,envmap
	mov	edx,Zbuffer
  ;      mov     edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw

;if 0
 .flat_draw_float:
    push  [.zz3f]
    push  [.zz2f]
    push  [.zz1f]

; calc color of triangle light vector dependent

	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,[first_p_index]
	add	eax,points_normals_rotated
	fld	dword[eax]
	mov	ebx,[second_p_index]
	add	ebx,points_normals_rotated
	fadd	dword[ebx]
	mov	ecx,[third_p_index]
	add	ecx,points_normals_rotated
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.x_temp_var] ;[esp-4]    ; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.y_temp_var];[esp-8]   ;  y
	mov	edx,[.x_temp_var]  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,[.y_temp_var] ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax



if 0
    mov   esi,light_vect
    mov   edi,points_normals_rotated
    add   edi,[first_p_index]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx

    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxub    xmm3,[minimum0]
;    pminub    xmm3,[maximum255]
    packuswb  xmm3,xmm3
    movd      edx,xmm3
end if




    mov   esi,Zbuffer
    mov   edi,buffer

    call  flat_triangle_z_float
    jmp     .end_draw
;end if

  .tex_mapping:
	push	[zz3]
	push	[zz2]
	push	word[zz1]
   ;  cmp    [hrt_flag],3          ; check tetrahedron object cause
   ;  je     @f
	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]
  ;      jmp    .no_tetra
  ;  @@:
  ;      push dword 256 * 65536 + 1
  ;      push dword 511 * 65536 + 511
  ;      push dword 1   * 65536 + 511

    .no_tetra:
	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,buffer   ; screen buffer
	mov	esi,texmap
	mov	edx,Zbuffer
	call	tex_triangle_z

	jmp	.end_draw


    .bump_mapping:
	push	Zbuffer
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,buffer
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_triangle_z
	jmp    .end_draw

    .two_tex:		    ; double texture mapping

	push	Zbuffer
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

   ;  cmp    [hrt_flag],3          ; check tetrahedron object cause
   ;  je     @f

	mov    eax,[third_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]
    ;    jmp    .no_tetra1
    ;@@:
    ;    push dword 256 * 65536 + 1
    ;    push dword 511 * 65536 + 511
    ;    push dword 1   * 65536 + 511

    ;.no_tetra1:



	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,buffer
	mov	esi,envmap
	mov	edx,texmap

	call	two_tex_triangle_z
	jmp    .end_draw


    .bump_tex_mapping:

	mov    eax,[third_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	push	texmap

	push	Zbuffer
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,points_normals_rotated    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

    ; cmp    [hrt_flag],3          ; check tetrahedron object cause
    ; je     @f
	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,tex_points
	push   dword[eax]

   ;     jmp    .no_tetra2
   ; @@:
   ;
   ;     push dword 511 * 65536 + 511
   ;     push dword 1   * 65536 + 511
   ;     push dword 256 * 65536 + 1
   ; .no_tetra2:



	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,buffer
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_tex_triangle_z






 .end_draw:
    popad
    pop   esi
    add   esi,6
;    cmp   dword[esi],-1
;    jnz   .draw_triangle
    pop    ecx
    dec    ecx
    jnz    .draw_triangle

    popad
;    rdtsc
;    pop    ebx
;    sub    eax,ebx

;    mov     ecx,10
;  .dc:
;    xor     edx,edx
;    mov     edi,10
;    div     edi
;    add     dl,30h
;    mov     [STRdata+ecx-1],dl
;    loop    .dc

   ; invoke      MessageBox,[hwnd],STRdata,_tsc_title,MB_RTLREADING
;   invoke stop_ticks
ret

endp

normalize_all_light_vectors:
	mov	edi,lights
     @@:
	call	normalize_vector	   ;       3dmath.inc
	add	edi,LIGHT_SIZE
	cmp	edi,lightsend	;ecx
	jl	@b
ret
read_hrt:
	fninit
	mov    esi,hrt_triangles
	mov    edi,triangles
	cld
	mov    [triangles_count_var],hrt_triangles_count
	mov    ecx,hrt_triangles_count
     @@:
	movsd
	movsw
	loop   @b
;        inc    [triangles_count_var]
;        cmp    dword[esi],-1
;        jne    @b
	movsd	    ; copy end mark too

;        mov    [triangles_count_var],hrt_triangles_count

	mov    esi,hrt_points
	mov    edi,points_r
	mov    [points_count_var],0
      @@:
	fild   word[esi]
	fstp   dword[edi]
	fild   word[esi+2]
	fstp   dword[edi+4]
	fild   word[esi+4]
	fstp   dword[edi+8]
	inc    [points_count_var]
	add    edi,12
	add    esi,6
	cmp    dword[esi],-1
	jne    @b
	movsd	 ;copy  end mark too

ret

read_from_file:   ;; this procedure coded orginally by Madis Kalme
	fninit
    ;    mov     edi,[triangles_ptr]
	mov	edi,triangles
	xor	ebx,ebx
	xor	ebp,ebp
	mov	[points_count_var],0
	mov	[triangles_count_var],0
  ; if USE_LFN = 0
      ;  mov     esi,SourceFile
  ; else
	mov	esi,[File_ptr]
  ; end if
	cmp	[esi],word 4D4Dh
	jne	.exit ;Must be legal .3DS file
;        cmp     dword[esi+2],EndFile-SourceFile
;        jne     .exit ;This must tell the length
	mov	eax,dword[esi+2]
  ;      cmp     eax,[fsize]
  ;      jne     .exit

	add	eax,esi
	mov	[EndFile],eax	 ;

	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,[EndFile]
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[points_count_var],cx

	mov	edx,ecx
	add	esi,8
     @@:
	push	edi
    ;    mov     edi,[points_ptr]
	mov	edi,points_r
	push	dword[esi+4]
	pop	dword[edi+ebx*2+0]
	push	dword[esi+8]
	pop	dword[edi+ebx*2+4]
	push	dword[esi+0]
	pop	dword[edi+ebx*2+8]
	pop	edi
;        fld     dword[esi+4]
;        fstp    dword[real_points+ebx*2+0]  ; x
;        fld     dword[esi+8]
;        fstp   dword[real_points+ebx*2+4]  ; y
;        fld     dword[esi+0]
;        fstp   dword[real_points+ebx*2+8]  ; z

	add	ebx,6
	add	esi,12
	dec	ecx
	jnz	@b
      @@:
  ;      mov     dword[points+ebx],-1
	push	edi
    ;    mov     edi,[points_ptr]
	mov	edi,points_r
	mov	dword[edi+ebx*2],-1	   ; end mark (not always in use)
	pop	edi
      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[triangles_count_var],cx
	add	esi,8
	;mov     edi,triangles
      @@:
	movsd
	movsw
	add	word[edi-6],bp
	add	word[edi-4],bp
	add	word[edi-2],bp
	add	esi,2
	dec	ecx
	jnz	@b
	add	ebp,edx
	jmp	.find4k
	mov	eax,-1 ;<---mark if OK
      .exit:
	mov	dword[edi],-1
ret

init_triangles_normals2:
	fninit
    ;    mov     ebx,[triangles_normals_ptr]
	mov	ebx,triangles_normals
    ;    mov     ebp,[triangles_ptr]
	mov	ebp,triangles
	movzx	ecx,[triangles_count_var]
     @@:
	push	ecx
	push	ebx
	mov	ebx,vectors
	movzx	esi,word[ebp]	       ; first point index
	lea	esi,[esi*3]
    ;    lea     esi,[points+esi*2]     ; esi - pointer to 1st 3d point
	shl	esi,2
	add	esi,points_r
	movzx	edi,word[ebp+2] 	 ; first point index
	lea	edi,[edi*3]
	shl	edi,2
  ;      add     edi,[points_ptr]
	add	edi,points_r
;        movzx   edi,word[ebp+2]        ; second point index
;        lea     edi,[edi*3]
;        lea     edi,[points+edi*2]     ; edi - pointer to 2nd 3d point

	call	make_vector_r
	add	ebx,12
	mov	esi,edi
	movzx	edi,word[ebp+4]        ; third point index
	lea	edi,[edi*3]
	shl	edi,2
      ;  add     edi,[points_ptr]
	add	edi,points_r
;        lea     edi,[points+edi*2]
	call	make_vector_r
	mov	edi,ebx 		; edi - pointer to 2nd vector
	mov	esi,ebx
	sub	esi,12			; esi - pointer to 1st vector
	pop	ebx
	call	cross_product
	mov	edi,ebx
	call	normalize_vector
	add	ebp,6
	add	ebx,12
	pop	ecx
	loop	@b
    ;    cmp     dword[ebp],-1
      ;  jne     @b
ret

init_point_normals:
.x equ dword [ebp-4]
.y equ dword [ebp-8]
.z equ dword [ebp-12]
.point_number equ word [ebp-26]
.hit_faces    equ word [ebp-28]

	fninit
	mov	  ebp,esp
	sub	  esp,28
	mov	  edi,points_normals ;[points_normals_ptr]
	mov	  .point_number,0
    .ipn_loop:
	mov	  .hit_faces,0
	mov	  .x,0
	mov	  .y,0
	mov	  .z,0
	mov	  esi,triangles;[triangles_ptr]
	xor	  ecx,ecx	       ; ecx - triangle number
    .ipn_check_face:
	xor	  ebx,ebx	       ; ebx - 'position' in one triangle
    .ipn_check_vertex:
	movzx	  eax,word[esi+ebx]    ;  eax - point_number
	cmp	  ax,.point_number
	jne	  .ipn_next_vertex
	push	  esi
	mov	  esi,ecx
	lea	  esi,[esi*3]
       ; lea       esi,[triangles_normals+esi*4]
	shl	  esi,2
	add	  esi,triangles_normals ;[triangles_normals_ptr]

	fld	  .x
	fadd	  dword[esi]
	fstp	  .x
	fld	  .y
	fadd	  dword[esi+4]
	fstp	  .y
	fld	  .z
	fadd	  dword[esi+8]
	fstp	  .z
	pop	  esi
	inc	  .hit_faces
	jmp	  .ipn_next_face
    .ipn_next_vertex:
	add	  ebx,2
	cmp	  ebx,6
	jne	  .ipn_check_vertex
    .ipn_next_face:
	add	  esi,6
	inc	  ecx
	cmp	  cx,[triangles_count_var]
	jne	  .ipn_check_face

	fld	  .x
	fidiv	  .hit_faces
	fstp	  dword[edi]
	fld	  .y
	fidiv	  .hit_faces
	fstp	  dword[edi+4]
	fld	  .z
	fidiv	  .hit_faces
	fstp	  dword[edi+8]
	call	  normalize_vector
	add	  edi,12  ;type vector 3d
	inc	  .point_number
	mov	  dx,.point_number
	cmp	  dx,[points_count_var]
	jne	  .ipn_loop

	mov	  esp,ebp
ret

include 'grd_cat.inc'
include 'tex_cat.inc'
include 'flat_cat.inc'
if Ext >= AVX
  include 'flat_cat_floatZavx.inc'
else
  include 'flat_cat_floatZ.inc'
end if
include '3DMATH.INC'
include 'procs_a.inc'
include 'bump_cat.inc'
include 'bump_tex.inc'
include 'two_tex.inc'
include 'grd_tex.inc'
include 'grd_line.inc'
include 'tex_line.inc'
include 'line.inc'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class     TCHAR	 'grtest',0
    _title     TCHAR	 'Ave Cruce Salus Mea'
  if Ext = SSE2
     .exxt     TCHAR	 ' SSE2'
  else if Ext = SSE3
     .exxt     TCHAR	 ' SSE3'
  else if Ext = SSE4.1
     .exxt     TCHAR	 ' SSE4.1'
  else if Ext = AVX
     .exxt     TCHAR	 ' AVX'
  end if
  fakebitmap   dd  0,0,0,0
    .end TCHAR 0
    _error     TCHAR	 'Startup failed.',0
    _tsc_title TCHAR	 'Clocks number',0
    sh_model   TCHAR	 'Nodes of object                     '
	.fl    TCHAR	 'Flat Shading                        '
	.gr    TCHAR	 'Gouraud Shading                     '
	.sp    TCHAR	 'Spherical Environment Mapping       '
	.bm    TCHAR	 'Bump Mapping                        '
	.tx    TCHAR	 'Texture Maping                      '
	.grtx  TCHAR	 'Gouraud Shading and Texture Mapping '
	.dtxx  TCHAR	 'Double Texture Mapping              '
	.bmtx  TCHAR	 'Bump and Texture Mapping Pararell   '
	.grl   TCHAR	 'Gouraud Shaded Line                 '
	.flf   TCHAR	 'Flat Shading with Float zBuffer     '
	.txl   TCHAR	 'Textured Line - Env. Mapping        '
	.tx12  TCHAR	 'Textured Line                       '
	.line  TCHAR	 'Simple line without z coord. interp.'

;    no_display  dw 11    ; Number of displaying models    '
    File_ptr	dd ?
    SourceFile:
;    file        'knot.3ds'
    EndFile	dd ?
    up		dd 0
    s_time	dd 0
    e_time	dd 0
    num_animations dd 3
    ccounter	   dd 0
    screen_width_var dd SIZE_X
    line_buffer_var dd buffer
    triangles_count_var  dw TRIANGLES_COUNT
    points_count_var	 dw POINTS_COUNT

;    splines     dd -0.5,-0.5,0.0
;                dd  0.0,0.5,-0.2
;                dd  0.5,-0.5,0.2
;    spline_steps     dd 20
;    curr_arc_index   dw 0
;    spl_index        dw 0

 ;   points_r:
 ;     dd -1.0, -1.0, 1.0
 ;     dd  1.0, -1.0, 1.0
 ;     dd  0.0,  1.0, 0.0
 ;     dd  0.0, -1.0, -1.0
 ;     dd -1 ;<- end marker

 ;   triangles:
 ;      dw 0,2,1, 3,2,0, 1,2,3,  0,1,3
 ;      dd -1 ;<- end marker

    tex_x_div2	dd  TEX_X / 2
    tex_y_div2	dd  TEX_Y / 2
    i3		dd  3
    i256	dw  256
    i255d	dd  255
    env_const	dd  1.05
    dot_max	dd  1.0
    dot_min	dd  0.0
    correct_tex dw  255


    scale	dd 200.0
    scale_plus	dd 1.2
    scale_minus dd 0.8
    xxadd:
		dw XRES/2
    yyadd	dw YRES/2
    zzadd	dw 1000
    draw_flag	db 11
    blur_flag	db 0
    hrt_flag	db 0
    map_flag	db 0
    bump_flag	db 0
    tex_flag	db 0
    piD128:
    one_deg	dd   0.024543692
    STRdata	db   '-1        '
    all_lights_size dw lightsend-lights

  lights:
    light_vect	dd   0.0,0.0,-1.0
    light_c_o:			   ;   +12
       dw   1,1,1,0
    light_c_min:		   ;   +20
       dw   1,1,1,0
    light_c_max:		   ;   +28
       dw   255,255,5,0
    shiness:
       dw   5			   ;   +36
    LIGHT_SIZE = ($-lights)
       dd   -0.5,-0.5,-1.0
			 ;   +12
       dw   1,255,1,0
			 ;   +20
       dw   1,1,1,0
			 ;   +28
       dw   255,255,255,0
       dw   5		 ;   +36

       dd   0.5,0.5,-1.0
				   ;   +12
       dw   13,1,1,0
				   ;   +20
       dw   70,30,70,0
				   ;   +28
       dw   25,255,255,0
       dw   5			   ;   +36
   lightsend:


 align 16
    minimum0:
       dw   0,0,0,0,0,0,0,0
    maximum255:
       dw   255,255,255,255,255,255,255,255
 align 16
    mask_blend:
       dd -1,-1,-1,-1
    tex_cutter:
       dd TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE
    blur_sub:
       dd 0x01010101, 0x01010101, 0x01010101, 0x01010101
 align 16
    muler1234:
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
align 16
    muler0_7:
    muler0123:
       dd 0.0
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
       dd 5.0
       dd 6.0
       dd 7.0
align 16
mask_line:
	   dq 0xffffffff00ffffff
	   dq 0xffffffffffffffff

filter	   TCHAR   '3ds objects (*.3ds)',0,'*.3ds',0,\
		   'All files (*.*)',0,'*.*',0,0
_not3ds    TCHAR   'Not an 3ds file or read error.',0


; Sanctssimi Cordis Christi section
   hrt_points:
;cordis
dw 125,175,0, 175,175,0, 212,212,0, 250,175,0, 300,175,0, 325,200,0, 325,250,0
dw 300,300,0, 212,350,0, 125,300,0, 100,250,0, 100,200,0,175,250,-20,250,250,-20
;crux
dw 175,125,0, 200,125,0, 200,100,0, 225,100,0, 225,125,0, 250,125,0, 250,150,0
dw 225,150,0, 225,200,0, 200,200,0, 200,150,0, 175,150,0
;cordis next layer
dw 125,175,20, 175,175,20, 212,212,20, 250,175,20, 300,175,20, 325,200,20
dw 325,250,20, 300,300,20, 212,350,20, 125,300,20, 100,250,20, 100,200,20
dw 175,250,40, 250,250,40
;crux
dw 175,125,20, 200,125,20, 200,100,20, 225,100,20, 225,125,20, 250,125,20
dw 250,150,20, 225,150,20, 225,200,20, 200,200,20, 200,150,20, 175,150,20
;crown
dw 50,250,-25, 50,250,25, 100,250,75, 175,250,100,  275,250,100, 350,250,75
dw 380,250,25, 380,250,-25,350,250,-75,275,250,-100,175,250,-100, 100,250,-75
dw 50,265,-25, 100,265,75, 275,265,100,380,265,25,  350,265,-75, 175,265,-100
;thorns
dw 50,250,-50, 75,260,103, 275,240,150, 365,250,25, 350,260,-41, 150,240,-125

	hrt_points_count = ($-hrt_points)/6
dd -1
    hrt_triangles:
dw 0,1,12, 1,2,12, 8,9,12, 9,10,12, 10,11,12, 11,0,12, 12,13,2, 12,13,8, 2,3,13
dw 3,4,13, 4,5,13, 5,6,13, 6,7,13, 7,8,13
;crux
dw 21,22,23, 23,24,21, 24,25,14, 24,14,18, 24,18,20, 18,19,20, 15,16,18
dw 16,17,18
;cordis next layer
dw 26,27,38, 27,28,38, 34,35,38, 35,36,38, 36,37,38,37,26,38,38,39,34,28,29,39
dw 29,30,39, 30,31,39, 31,32,39, 32,33,39, 33,34,39, 38,39,28
; crux next layer
dw 47,48,49, 49,50,47, 50,51,40, 50,40,44, 50,42,44
dw 42,43,44, 46,50,44, 44,45,46
;border cordis
dw 0,1,26, 26,27,1, 1,2,27, 27,28,2, 2,3,28, 28,29,3, 3,4,29, 29,30,4, 4,5,30
dw 30,31,5, 5,6,31, 31,32,6, 6,7,32, 32,33,7, 7,8,33, 33,34,8, 8,9,34, 34,35,9
dw 9,10,35, 35,36,10, 10,11,36, 36,37,11, 11,0,37, 37,26,0
;border crux
dw 14,15,40, 40,41,15, 15,16,41, 41,42,16, 16,17,42, 42,43,17, 17,18,43
dw 43,44,18, 18,19,44, 44,45,19, 19,20,45, 45,46,20, 20,21,46, 46,47,21
dw 21,22,47, 47,48,22, 23,24,49, 49,50,24, 24,25,50, 50,51,25, 25,14,51
dw 14,51,40
;crown
dw 52,53,64, 53,54,65, 54,55,65, 55,56,66, 56,57,66, 57,58,67, 58,59,67
dw 59,60,68, 60,61,68, 61,62,69, 62,63,69, 63,64,52
;thorns
dw 52,64,70, 54,65,71, 56,66,72, 58,67,73, 68,60,74, 69,62,75
	hrt_triangles_count = ($-hrt_triangles)/6
dd -1
;box


tetra_points_r:
dd -1.0, -1.0, 1.0
dd  1.0, -1.0, 1.0
dd  0.0,  1.0, 0.0
dd  0.0, -1.0,-1.0
tetra_points_count = 4
dd -1 ;<- end marker

tetra_triangles:
dw 0,2,1, 3,2,0, 1,2,3,  0,1,3
tetra_triangles_count = 4
dd -1 ;<- end marker
tetra_tex_points:
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dd -1

;box_points:
;    dw 100,0,0, 200,0,0, 200,200,0, 100,100,0
;    dw 100,0,100, 200,0,100, 200,200,100, 100,100,100
;box_points_count = ($-box_points)/6
;    dd -1
;box_triangles:
;    dw 0,1,2, 0,2,3, 4,5,6, 4,6,7
;box_triangles_count = ($-box_triangles)/6
;    dd -1
;box_tex_points:
;    dw 1,1, 511,1, 511,511, 1,511 ,1,1, 511,1, 511,511, 1,511
;    dd -1
;;box_tex_triangles
;;    dw 1,2,3, 1,3,4, 1,2,3, 1,3,4

    msg  MSG
    rect RECT
    ofn  OPENFILENAME sizeof.OPENFILENAME,0,0,filter,0,0,0,fname,260 ;MAXSIZE

     wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,1,NULL,_class
;    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,COLOR_BTNFACE+1,NULL,_class
 ; threads is present and future :)
;    hThreadArray        dq 64 dup ?
;    ThreadMaskArray     dq 64 dup ?
;    ProcessAffinityMask dd ?
;    SystemAffinityMask  dd ?
; align 8
;    CoreCount           dd ?

    fname     rb      260 ;MAXSIZE
    BytesRead dd ?
    hfile     dd ?
    FileSize  dd ?
    hheap     dd ?
    pmem      dd ?
align 16
    cos_beta:
		  rd 1
    sin_beta	  dd ?
    neg_cos_beta  dd ?
    neg_sin_beta  dd ?
align 16
    cos_gamma:
		  rd 1
    sin_gamma	  dd ?
    neg_cos_gamma dd ?
    neg_sin_gamma dd ?

    rand_seed dw ?
    hwnd      dd ?
    hdc       dd ?
    bmi      BITMAPINFOHEADER
    align 16
    sse_repository:
       rd 512
  align 16
    buffer    rd XRES * YRES
    Zbuffer   rd XRES * YRES
    bump_map  rb TEX_X * TEX_Y
    envmap    rd TEX_X * TEX_Y
    color_map rd TEX_X * TEX_Y
    texmap    rd TEX_X * TEX_Y
    points_rotated rb 100000
    tex_points	rb 100000	; bump_map  and texture coords
				; each point word x, word y
    hrt_points_r:
       rb 100000
    points_r:
       rb 100000
    triangles:
       rb 100000
    triangles_normals:
       rb 100000
    points_normals:
       rb 100000
    points_normals_rotated:
       rb 100000

    col1:
		   dd ?
    col2	   dd ?
    col3	   dd ?
    first_p_index:
		   dd ?
    second_p_index dd ?
    third_p_index  dd ?   ; don't change order
    zz1:
	dw ?
    zz2 dw ?
    zz3 dw ? ;-> don't change order

    vectors rb 24
    angles  rb 24
    matrix  rb 36
    cos_tab rd 360
    sin_tab rd 360


section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM',\
    comdlg32,'COMDLG32'    ;   timing,'timing.dll'
    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'
    include '\include\api\comdlg32.inc'
 ;   include 'timing.inc'
    import winmm,timeGetTime,'timeGetTime'




